<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- 
IGAC proyecto SNC
@author: ariel.ortiz

@description Página principal del caso de uso CU-TV-0F-07 Cargar al SNC
    Contiene un panel para mostrar la informacion geografica de la oferta, Departamento, Municipio y Zona.
    Luego una tabla con las ofertas ingresadas y la posibilidad de modificar o finalizar.
    Finalmente los botones de cargar al sistema, registrar la oferta y cerrar área asignada.
    
@cu CU-TV-0F-07
@version 2.0
-->


<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="/templates/generalCU.xhtml">

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .::Carga al SNC::.
    </ui:define>

    <ui:define name="content">

        <h:outputScript library="javascript" name="snc_visor_client.js"
                        target="head" />
        <h:outputStylesheet library="css" name="snc_visor_client.css" />

        <p:ajaxStatus onstart="statusDialog2.show();"
                      onsuccess="statusDialog2.hide();" onerror="statusDialog2.hide();" />

        <p:messages id="msgsCargaAlSNC" showDetail="false" globalOnly="false" />

        <p:focus />

        <h:form id="cargaAlSNCForm">

            <p:fieldset>
                <legend>
                    <h:outputText value="Cargar ofertas" styleClass="legendTitle" />
                </legend>

                <p:spacer height="10" width="0" />

                <h:panelGrid columns="2" cellspacing="7"
                             columnClasses="colPequena, colGrande">
                    <h:outputLabel value="Departamento: " styleClass="outputLabelStyle" />
                    <h:outputText
                        value="#{cargarOfertasSNC.regionCapturaOferta.areaCapturaOferta.departamento.nombre}"
                        styleClass="outputTextStyle" />
                    <h:outputLabel value="Municipio: " styleClass="outputLabelStyle" />
                    <h:outputText
                        value="#{cargarOfertasSNC.regionCapturaOferta.areaCapturaOferta.municipio.nombre}"
                        styleClass="outputTextStyle" />
                    <h:outputLabel value="Zona: " styleClass="outputLabelStyle"
                                   rendered="#{not empty cargarOfertasSNCzonaSeleccionada}" />
                    <h:outputText
                        value="#{cargarOfertasSNC.regionCapturaOferta.areaCapturaOferta.zona.nombre}"
                        styleClass="outputTextStyle"
                        rendered="#{not empty cargarOfertasSNCzonaSeleccionada}" />
                </h:panelGrid>

                <p:spacer height="10" width="0" />

                <p:panel header="Ofertas inmobiliarias registradas">

                    <p:spacer height="10" width="0" />

                    <p:dataTable id="ofertasTable" var="oferta"
                                 value="#{cargarOfertasSNC.ofertasInmob}"
                                 emptyMessage="No se encontraron ofertas inmobiliarias registradas o sin finalizar para la región"
                                 paginator="true" rows="10"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink}
                                 {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="10,20,50" paginatorPosition="bottom">

                        <p:column headerText="Opciones">
                            <p:commandButton title="Ver detalles" icon="ui-icon-search"
                                             update=":detallesOfertaPanel" ajax="true"
                                             oncomplete="detalleOfertaWV.show();">
                                <f:setPropertyActionListener value="#{oferta}"
                                                             target="#{detalleOfertaInmob.currentOferta}" />
                            </p:commandButton>
                            <p:commandButton id="verMapaZoom" widgetVar="verMapaVarZoom"
                                             title="Zoom a la oferta" immediate="true"
                                             icon="ui-icon ui-icon-zoomin" onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide();"
                                             onclick="cargarMapaZoomToFeature('#{cargarOfertasSNC.applicationClientName}',
                                                             '#{cargarOfertasSNC.tokenParam}',
                                                             '#{cargarOfertasSNC.moduleLayer}',
                                                             '#{cargarOfertasSNC.moduleTools}',
                                                             '#{oferta.cadenaDeManzanasVeredas}');"
                                             disabled="#{!oferta.esVisorVisible}">
                            </p:commandButton>
                            <p:commandButton title="Modificar" icon="ui-icon-pencil"
                                             ajax="false" update=":registroOfertaInmobiliariaFormId"
                                             disabled="#{oferta.estaFinalizada}"
                                             action="#{cargarOfertasSNC.registrarModificarOferta}">
                                <f:setPropertyActionListener value="#{oferta}"
                                                             target="#{registroOfertaInmob.selectedOfertaInmobiliaria}" />
                                <f:setPropertyActionListener value="true"
                                                             target="#{registroOfertaInmob.banderaEsEdicion}" />
                            </p:commandButton>
                            <p:commandButton title="Finalizar oferta" icon="ui-icon-disk"
                                             action="#{cargarOfertasSNC.finalizarOferta}"
                                             disabled="#{oferta.estaFinalizada}" update=":cargaAlSNCForm">
                                <f:setPropertyActionListener value="#{oferta}"
                                                             target="#{cargarOfertasSNC.ofertaInmobSeleccionada}" />
                            </p:commandButton>
                        </p:column>

                        <!--TODO :: ariel.ortiz :: verificar tabulaciones (deben ser a 4 espacios). Aquí­ se ve descuadrado  -->
                        <p:column headerText="Código oferta"
                                  filterBy="#{oferta.codigoOferta}">
                            #{oferta.codigoOferta}					 
                        </p:column>

                        <p:column headerText="Tipo predio">
                            #{oferta.tipoPredio}					 
                        </p:column>

                        <p:dataList value="#{oferta.ofertaPredios}" var="predio"
                                    rendered="#{not empty oferta.ofertaPredios}"
                                    style="background: none;border: none;">
                            #{predio.numeroPredial}
                        </p:dataList>

                        <p:column headerText="Tipo inmueble"
                                  filterBy="#{oferta.tipoInmueble}">
                            #{oferta.tipoInmueble}					 
                        </p:column>

                        <p:column>
                            <f:facet name="header">
                                Proyecto <br /> inmobiliario
                            </f:facet>
                            <h:outputText value="#{oferta.esProyecto ? 'SÍ' : 'NO'}" />
                        </p:column>

                        <p:column headerText="Condicion jurídica">
                            #{oferta.condicionJuridica}					 
                        </p:column>

                        <p:column headerText="Dirección">
                            #{oferta.direccion}					 
                        </p:column>

                        <p:column headerText="Tipo investigación">
                            #{oferta.tipoInvestigacion}					 
                        </p:column>

                        <p:column headerText="Fecha oferta" sortBy="#{oferta.fechaOferta}">
                            #{oferta.fechaOferta}					 
                        </p:column>

                        <p:column headerText="Nombre fuente">
                            #{oferta.nombreFuente}					 
                        </p:column>

                    </p:dataTable>

                    <p:spacer height="10" width="0" />

                </p:panel>

                <p:spacer height="10" width="0" />

                <h:panelGrid columns="3" id="botonesPG" cellspacing="7">
                    <p:commandButton value="Cargar al SNC" id="botonCarga"
                                     disabled="true" icon="ui-icon-circle-arrow-s" />
                    <p:commandButton value="Registrar oferta" id="botonRegistro"
                                     icon="ui-icon-circle-plus" onstart="statusDialog2.show();"
                                     oncomplete="statusDialog2.hide();" ajax="false"
                                     action="#{cargarOfertasSNC.registrarModificarOferta}"
                                     disabled="#{cargarOfertasSNC.banderaRegionCerrada}" />
                    <p:commandButton value="Cerrar región asignada" id="botonCierre"
                                     onstart="statusDialog2.show(); "
                                     oncomplete="statusDialog2.hide(); 
                                     handleCompleteSIC(xhr, status, args, cerrarRegionConfirmationWV, true);"
                                     icon="ui-icon-circle-close"
                                     disabled="#{cargarOfertasSNC.banderaRegionCerrada}" />
                </h:panelGrid>

                <p:spacer height="10" width="0" />

            </p:fieldset>

            <p:separator style="width:925px;height:3px" />
            <p:spacer height="7" width="0" />
            <p:outputPanel layout="block" style="text-align:right">
                <p:commandButton value="Cerrar" action="#{cargarOfertasSNC.cerrar}"
                                 icon="ui-icon-circle-close" immediate="true" ajax="false" />
                <p:spacer height="0" width="30" />
            </p:outputPanel>
            <p:spacer height="20" width="0" />
        </h:form>


        <!--                             DIALOGS                             -->
        <p:dialog header="Detalles de la oferta inmobiliaria" dynamic="true"
                  widgetVar="detalleOfertaWV" modal="true" appendToBody="true"
                  resizable="true" position="center" height="520" width="900">
            <ui:include src="../detallesOferta.xhtml">
                <ui:param name="ofertaInmobiliariaParam"
                          value="#{detalleOfertaInmob.currentOferta}" />
            </ui:include>
        </p:dialog>

        <p:dialog header="Fotografías de la oferta inmobiliaria"
                  dynamic="true" widgetVar="fotosOfertaWV" modal="true"
                  appendToBody="true" resizable="true" position="center" height="550"
                  width="900">
            <ui:include src="../galeriaFotografiasComponent.xhtml">
                <ui:param name="managedBeanParam" value="#{detalleOfertaInmob}" />
                <ui:param name="selectedFotografiaListParam"
                          value="#{detalleOfertaInmob.currentOferta.fotografias}" />
                <ui:param name="banderaCargaParam" value="false" />
                <ui:param name="compositeWVParam" value="fotosOfertaWV" />
                <ui:param name="cIdParam" value="fotosG" />
            </ui:include>
        </p:dialog>

        <misc:ultimateConfirmDialogCC id="mensajeConfirmacion"
                                      confirmMessage="Al cerrar el área asignada no se podrán adicionar nuevas ofertas a dicha área ¿Está seguro de que desea guardar y terminar?"
                                      confirmUpdateOnYes=":msgsCargaAlSNC, :cargaAlSNCForm"
                                      confirmDialogWV="cerrarRegionConfirmationWV"
                                      voidActionOnYes="#{cargarOfertasSNC.cerrarRegion}" width="450" 
                                      useStringActionOnYes="false" useStringActionOnNo="false" actionOnNoIsClose="true" />

        <ui:include src="/util/visorGeografico.xhtml" />

    </ui:define>
</ui:composition>
